<template>
    <div class="app-container">
      <el-row :gutter="20">
        <!--用户数据-->
        <el-col :span="24" :xs="24">
          <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
            <el-form-item label="卡号" prop="cardNo">
              <el-input
                v-model="queryParams.cardNo"
                placeholder="请输入卡号"
                clearable
                style="width: 240px"
                @keyup.enter.native="handleQuery"
              />
            </el-form-item>
            <el-form-item label="持卡人" prop="userName">
              <el-input
                v-model="queryParams.userName"
                placeholder="请输入持卡人"
                clearable
                style="width: 240px"
                @keyup.enter.native="handleQuery"
              />
            </el-form-item>
            <el-form-item label="手机号" prop="phone">
              <el-input
                v-model="queryParams.phone"
                placeholder="请输入手机号"
                clearable
                style="width: 240px"
                @keyup.enter.native="handleQuery"
              />
            </el-form-item>
            <el-form-item label="卡类型" prop="entityCardConfigId">
              <el-select v-model="queryParams.entityCardConfigId" clearable placeholder="请选择卡类型">
                <el-option
                  v-for="dict in tableListCopy"
                  :key="dict.id"
                  :label="dict.cardName"
                  :value="dict.id">
                </el-option>
              </el-select>
            </el-form-item>
            <el-form-item>
              <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
              <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
            </el-form-item>
          </el-form>
  
          <el-row :gutter="10" class="mb8">
            <el-col :span="1.5">
              <el-button
                type="primary"
                plain
                icon="el-icon-plus"
                size="mini"
                @click="handleAdd"
                v-hasPermi="configPermi.add"
              >添加新卡</el-button>
            </el-col>
            <right-toolbar :showSearch.sync="showSearch" @queryTable="getList" :columns="columns"></right-toolbar>
          </el-row>
  
          <el-table v-loading="loading" :data="tableList" @selection-change="handleSelectionChange">
            <el-table-column type="index" label="序号" align="center"  />
            <el-table-column label="卡号" align="center" key="cardNo" prop="cardNo" v-if="columns[0].visible" :show-overflow-tooltip="true" />
            <el-table-column label="持卡人" align="center" key="userName" prop="userName" v-if="columns[1].visible" :show-overflow-tooltip="true" />
            <el-table-column label="手机号" align="center" key="phone" prop="phone" v-if="columns[2].visible" :show-overflow-tooltip="true" />
            <el-table-column label="卡类型" align="center" key="cardName" prop="cardName" v-if="columns[3].visible" :show-overflow-tooltip="true" />
            <el-table-column label="激活时间" align="center" key="effectiveDate" prop="effectiveDate" v-if="columns[4].visible" :show-overflow-tooltip="true" />
            <el-table-column label="使用期限" align="center" key="useType" prop="useType" v-if="columns[5].visible" :show-overflow-tooltip="true">
              <template slot-scope="scope">
                <span>{{ setUseType(scope.row) }}</span>
              </template>
            </el-table-column>
            <el-table-column label="卡余额" align="center" key="amount" prop="amount" v-if="columns[6].visible" :show-overflow-tooltip="true" />
            <el-table-column label="卡积分" align="center" key="credit" prop="credit" v-if="columns[7].visible" :show-overflow-tooltip="true" />
            <el-table-column label="充值余额" align="center" key="storageAmount" prop="storageAmount" v-if="columns[8].visible" :show-overflow-tooltip="true" />
            <el-table-column label="卡状态" align="center" key="cardStatus" prop="cardStatus" v-if="columns[9].visible" :show-overflow-tooltip="true">
              <template slot-scope="scope">
                <dict-tag :options="dict.type.tourism_physicalCardManagement_cardStatus" :value="scope.row.cardStatus"/>
              </template>
            </el-table-column>
            <el-table-column label="禁用/启用" align="center" key="status1" prop="status1" v-if="columns[10].visible" :show-overflow-tooltip="true">
              <template slot-scope="scope">
                <switchBox 
                :defaultChecked="true" 
                v-model="scope.row.status" 
                @changeFun="openAttraction(scope.row)" 
                :disabled="false"
                :active-value="1"
                :inactive-value="0"
                 />
              </template>
            </el-table-column>
            <el-table-column label="最近消费时间" align="center" key="newOrderTime" prop="newOrderTime" v-if="columns[11].visible" :show-overflow-tooltip="true" />
            <el-table-column
              label="操作"
              align="center"
              width="160"
              class-name="small-padding fixed-width"
            >
              <template slot-scope="scope" >
                <el-button
                  size="mini"
                  type="text"
                  icon="el-icon-document"
                  @click="handleDetails(scope.row)"
                  v-hasPermi="configPermi.details"
                >详情</el-button>
                <el-dropdown size="mini" @command="(command) => handleCommand(command, scope.row)" v-hasPermi="['system:user:resetPwd', 'system:user:edit']">
                    <el-button size="mini" type="text" icon="el-icon-d-arrow-right">更多</el-button>
                    <el-dropdown-menu slot="dropdown">
                        <el-dropdown-item command="handleResetPwd" icon="el-icon-key"
                        v-hasPermi="configPermi.resetPwd">设置积分</el-dropdown-item>
                        <el-dropdown-item command="handleAuthRole" icon="el-icon-circle-check"
                        v-hasPermi="configPermi.AuthRole">设置储值</el-dropdown-item>
                        <el-dropdown-item command="handleEdit" icon="el-icon-circle-check"
                        v-hasPermi="configPermi.edit">编辑</el-dropdown-item>
                        <el-dropdown-item command="handleResetPassword" icon="el-icon-circle-check"
                        v-hasPermi="configPermi.Password">重置密码</el-dropdown-item>
                    </el-dropdown-menu>
                </el-dropdown>
              </template>
            </el-table-column>
          </el-table>
  
          <pagination
            v-show="total>0"
            :total="total"
            :page.sync="queryParams.pageNum"
            :limit.sync="queryParams.pageSize"
            @pagination="getList"
          />
        </el-col>
      </el-row>
      <!--  新增或修改  -->
      <addAndEdit ref="addAndEdit" @refresh="getList" />
      <!--  详情 -->
      <detailsBox ref="detailsBox" />

      <setIntegralForm ref="setIntegralForm" @refresh="getList" />

      <setStoredValue ref="setStoredValue" @refresh="getList" />
    </div>
  </template>
  
  <script>
  import { 
    listTableApi, 
    delTableParamsApi,
    updateTableApi
  } from "@/api/CURD";
  import addAndEdit from "./formBox/physicalCardManagementForm.vue"
  import detailsBox from "./detailsBox/physicalCardManagementDetails.vue"
  import setIntegralForm from "./formBox/setIntegralForm.vue"
  import setStoredValue from "./formBox/setStoredValue.vue"
  export default {
    name: "User",
    dicts: ['tourism_IntegralRecord_cardType','tourism_physicalCardManagement_cardStatus'],
    components: {addAndEdit,detailsBox,setIntegralForm,setStoredValue},
    data() {
      return {
        title: "实体卡管理",// 通用标题
        configPermi: {
          add: ['physicalCard:physicalCardManagement:add'], // 新增权限
          details: ['physicalCard:physicalCardManagement:details'], // 详情权限
          delect: ['physicalCard:physicalCardManagement:delect'], // 删除权限
          edit: ['physicalCard:physicalCardManagement:edit'], // 编辑权限
          upload: [''],// 导入权限
          export: [''],// 导出权限
          resetPwd: ['physicalCard:physicalCardManagement:resetPwd'],// 设置积分
          AuthRole: ['physicalCard:physicalCardManagement:AuthRole'],// 设置储值
          Password: ['physicalCard:physicalCardManagement:Password'], // 重置密码
        },
        configUrl: {
          list: '/merchant/merchantEntitycard/pageList', // 列表地址
          delect: '', // 删除地址
          upload: '',// 导入地址
          download:'', // 下载模板地址
          export: '',// 导出地址
          updateStatus: '/merchant/merchantEntitycard/updateStatus', // 编辑地址
          resetPassword: '/merchant/merchantEntitycard/resetPassword',
          listCopy: '/merchant/merchantEntitycardConfig/pageList'
        },
        // 遮罩层
        loading: true,
        // 选中数组
        ids: [],
        // 非单个禁用
        single: true,
        // 非多个禁用
        multiple: true,
        // 显示搜索条件
        showSearch: true,
        // 总条数
        total: 0,
        // 用户表格数据
        tableList: null,
        // 查询参数
        queryParams: {
          pageNum: 1,
          pageSize: 10,
        },
        dateRange: [],
        // 控制列表是否显示
        columns: [
          { key: 0, label: `卡号`, visible: true },
          { key: 1, label: `持卡人`, visible: true },
          { key: 2, label: `手机号`, visible: true },
          { key: 3, label: `卡类型`, visible: true },
          { key: 4, label: `身份证号`, visible: true },
          { key: 5, label: `激活时间`, visible: true },
          { key: 6, label: `卡余额`, visible: true },
          { key: 7, label: `卡积分`, visible: true },
          { key: 8, label: `充值余额`, visible: true },
          { key: 9, label: `状态`, visible: true },
          { key: 10, label: `禁用/启用`, visible: true },
          { key: 11, label: `最近消费时间`, visible: true },
        ],
        tableListCopy: []// 实体卡类型
      };
    },
    created() {
      this.getListCopy()
      this.getList();
    },
    methods: {
      /** 查询实体卡类型列表 */
      getListCopy() {
        listTableApi(
          this.configUrl.listCopy,
          this.addDateRange(
            this.queryParams, 
            this.dateRange)).then(response => {
              this.tableListCopy = response.data.rows;
          }
        ).catch (error=>{
          console.error('获取列表失败!!!!',error)
          this.tableListCopy = [];
        }) 
      },
      /** 查询用户列表 */
      getList() {
        this.loading = true;
        listTableApi(
          this.configUrl.list,
          this.addDateRange(
            this.queryParams, 
            this.dateRange)).then(response => {
              this.tableList = response.data.rows;
              this.total = response.data.total;
              this.loading = false;
          }
        ).catch (error=>{
          console.error('获取列表失败!!!!',error)
          this.tableList = [];
          this.total = 0;
          this.loading = false
        }) 
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.dateRange = [];
        this.queryParams = {
          pageNum: 1,
          pageSize: 10,
        }
        this.handleQuery();
      },
      // 多选框选中数据
      handleSelectionChange(selection) {
        this.ids = selection.map(item => item.id);
        this.single = selection.length != 1;
        this.multiple = !selection.length;
      },
      /** 新增按钮操作 */
      handleAdd() {
        if(this.$refs.addAndEdit) {
          this.$refs.addAndEdit.initData(this.title + '新增', "ADD",{})
        }
      },
      /** 修改按钮操作 */
      handleUpdate(row) {
        if(this.$refs.addAndEdit) {
          this.$refs.addAndEdit.initData(this.title + '编辑', "EDITInit",{...row})
        }
      },
      handleDetails(row){
        if(this.$refs.detailsBox) {
          this.$refs.detailsBox.initData(this.title + '详情', "EDITInit",{...row})
        }
      },
      /** 删除按钮操作 */
      handleDelete(row) {
        const ids = row.id || this.ids;
        this.$modal.confirm('是否确认删除数据项？').then( () => {
          return delTableParamsApi(this.configUrl.delect,{
            id: ids
          });
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch((e) => {
          console.error("删除失败====",e)
        });
      },
      /** 导出按钮操作 */
      handleExport() {
        this.download(this.configUrl.export, {
          ...this.queryParams
        }, `${this.title }_${new Date().getTime()}.xlsx`)
      },
      /** 导入按钮操作 */
      handleImport() {
        if(this.$refs.upload) {
          this.$refs.upload.initData({
            width: '400px',
            // 弹出层标题（用户导入）
            title: this.title + "导入",
            // 下载模板地址
            importTemplate: this.configUrl.download,
            // 上传的地址
            url: this.configUrl.upload
          })
        }
      },
      /** 开/闭 园 */
      openAttraction(row) {
        this.$modal.confirm(`是否确认${row.status == 0 ? '启用' : '禁用'} ${row.cardNo||''}吗？`).then( () => {
          return updateTableApi(this.configUrl.updateStatus,{
            id: row.id,
            status: row.status == 1 ? 0 : 1
          });
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess(`${row.status == 0 ? '启用' : '禁用'}成功`);
        }).catch((e) => {
          console.error("失败====",e)
        });
      },
      /**  重置密码   */
      handleResetPassword(row){
        this.$modal.confirm(`是否确认重置卡号 ${row.cardNo||''}的密码为000000吗？`).then( () => {
          return updateTableApi(this.configUrl.resetPassword,{
            id: row.id,
          });
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess(`重置成功`);
        }).catch((e) => {
          console.error("失败====",e)
        });
      },
        handleResetPwd(row) {
            if(this.$refs.setIntegralForm) {
            this.$refs.setIntegralForm.initData('设置积分', "EDIT",{...row})
            }
        },
        handleAuthRole(row) {
            if(this.$refs.setStoredValue) {
            this.$refs.setStoredValue.initData('设置储值', "EDIT",{...row})
            }
        },
        // 更多操作触发
        handleCommand(command, row) {
          switch (command) {
              case "handleResetPwd":
              this.handleResetPwd(row);
              break;
              case "handleAuthRole":
              this.handleAuthRole(row);
              break;
              case "handleEdit":
              this.handleUpdate(row);
              break;
              case "handleResetPassword":
              this.handleResetPassword(row);
              break;
              default:
              break;
          }
        },
        /** 设置使用期限  */
        setUseType(row){
          if(row.useType == 1) {
            return '永久生效'
          }else if(row.useType == 2) {
            return '' + (row.useDay || '') + '天有效'
          }else if(row.useType == 3) {
            return '' + row.useEndDay + '内有效'
          }else{
            return '--'
          }
        },
    }
  };
  </script>
  